# Class LDC

java.lang.Object
org.apache.bcel.generic.Instruction
org.apache.bcel.generic.CPInstruction
org.apache.bcel.generic.LDC

All Implemented Interfaces:
  `Cloneable, ExceptionThrower, IndexedInstruction, PushInstruction, StackProducer, TypedInstruction`

Direct Known Subclasses:
  `LDC_W`

public class LDC extends CPInstruction implements PushInstruction, ExceptionThrower
LDC - Push item from constant pool.

    Stack: ... -> ..., item

- ## Field Summary

  ### Fields inherited from class CPInstruction

  `index`

  ### Fields inherited from class Instruction

  `length, opcode`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LDC(int index)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Call corresponding visitor method(s).
  `void`
  `dump(DataOutputStream out)`
  Dump instruction as byte code to stream out.
  `Class<?>[]`
  `getExceptions()`
  `Type`
  `getType(ConstantPoolGen cpg)`
  `Object`
  `getValue(ConstantPoolGen cpg)`
  `protected void`
  `initFromFile(ByteSequence bytes, boolean wide)`
  Reads needed data (for example index) from file.
  `final void`
  `setIndex(int index)`
  Sets the index to constant pool and adjust size.
  `protected final void`
  `setSize()`

  ### Methods inherited from class CPInstruction

  `getIndex, toString, toString`

  ### Methods inherited from class Instruction

  `consumeStack, copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface StackProducer

  `produceStack`

- ## Constructor Details

  - ### LDC

    public LDC(int index)

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Call corresponding visitor method(s). The order is: Call visitor methods of implemented interfaces first, then call methods according to the class hierarchy in descending order, i.e., the most specific visitXXX() call comes last.
    Specified by:
      `accept` in class `Instruction`
    Parameters:
      `v` - Visitor object

  - ### dump

    public void dump(DataOutputStream out) throws IOException
    Dump instruction as byte code to stream out.
    Overrides:
      `dump` in class `CPInstruction`
    Parameters:
      `out` - Output stream
    Throws:
      `IOException` - Thrown when an I/O exception of some sort has occurred.

  - ### getExceptions

    public Class<?>[] getExceptions()
    Specified by:
      `getExceptions` in interface `ExceptionThrower`

  - ### getType

    public Type getType(ConstantPoolGen cpg)
    Specified by:
      `getType` in interface `TypedInstruction`
    Overrides:
      `getType` in class `CPInstruction`
    Returns:
      type related with this instruction.

  - ### getValue

    public Object getValue(ConstantPoolGen cpg)

  - ### initFromFile

    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException
    Reads needed data (for example index) from file.
    Overrides:
      `initFromFile` in class `CPInstruction`
    Parameters:
      `bytes` - input stream
      `wide` - wide prefix?
    Throws:
      `IOException` - may be thrown if the implementation needs to read data from the file

  - ### setIndex

    public final void setIndex(int index)
    Sets the index to constant pool and adjust size.
    Specified by:
      `setIndex` in interface `IndexedInstruction`
    Overrides:
      `setIndex` in class `CPInstruction`
    Parameters:
      `index` - in constant pool.

  - ### setSize

    protected final void setSize()